/*---------------------------------------------------------------------------*/
/*                                PRG-2051                                   */
/*                                                                           */
/* Device programmer for the Atmel 89C2051 and 89C1051 microcontrollers.     */
/*                                                                           */
/* Filename:    BIOS.C                                                       */
/* Description: Basic Input/Output System.                                   */
/*                                                                           */
/* Copyright (c) 1995,1996,1997 Electronic Design Associates.                */
/* All rights reserved.                                                      */
/*                                                                           */
/*---------------------------------------------------------------------------*/

#include <prg2051.h>
#include <hardware.h>
#include <reg52.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <uart.h>

void vcc_off(void)
{
  VCC_CTRL=1;
}

void vcc_on(void)
{
  VCC_CTRL=0;
}

void vpp_on(void)
{
  VPP_CTRL=1;
}

void vpp_off(void)
{
  VPP_CTRL=0;
}

void reset_on(void)
{
  RST_CTRL=1;
}

void reset_off(void)
{
  RST_CTRL=0;
}

void prog_on(void)
{
  PROG=1;
}

void prog_off(void)
{
  PROG=0;
}

void clock_on(void)
{
  CLOCK=1;
}

void clock_off(void)
{
  CLOCK=0;
}

void latch_enable(void)
{
  LATCH_EN=0;
}

void latch_disable(void)
{
  LATCH_EN=1;
}

void output_enable(void)
{
  OUTPUT_EN=0;
}

void output_disable(void)
{
  OUTPUT_EN=1;
}

void boot_enable(void)
{
  BOOT_EN=0;
}

void set_data(char byte)
{
  XBYTE[0x0000]=byte;
}

char get_data(void)
{
  return(XBYTE[0x0000]);
}

void set_cmd(char cmd)
{
  switch(cmd) {
    case WRITE_DATA:
      CMD0=0;
      CMD1=1;
      CMD2=1;
      CMD3=1;
      break;
    case READ_DATA:
      CMD0=0;
      CMD1=0;
      CMD2=1;
      CMD3=1;
      break;
    case LOCK_BIT1:
      CMD0=1;
      CMD1=1;
      CMD2=1;
      CMD3=1;
      break;
    case LOCK_BIT2:
      CMD0=1;
      CMD1=1;
      CMD2=0;
      CMD3=0;
      break;
    case CHIP_ERASE:
      CMD0=1;
      CMD1=0;
      CMD2=0;
      CMD3=0;
      break;
    case READ_SIGN:
      CMD0=0;
      CMD1=0;
      CMD2=0;
      CMD3=0;
      break;
  }
}
