/*---------------------------------------------------------------------------*/
/*                                PRG-2051                                   */
/*                                                                           */
/* Device programmer for the Atmel 89C2051 and 89C1051 microcontrollers.     */
/*                                                                           */
/* Filename:    MAIN.C                                                       */
/* Description: Main program loop.                                           */
/*                                                                           */
/* Copyright (c) 1995,1996,1997 Electronic Design Associates.                */
/* All rights reserved.                                                      */
/*                                                                           */
/*---------------------------------------------------------------------------*/

#include <prg2051.h>
#include <hardware.h>
#include <reg52.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <uart.h>
#include <bios.h>
#include <subrs.h>

char mstimer = 0;

/*---------------------------------------------------------------------------*/
/*                                 main()                                    */
/*                                                                           */
/*---------------------------------------------------------------------------*/
main() {
unsigned long int temp;

  TMOD = 0x02;			/* timer 0 is 8-bit auto reload */
  TH0 = 26;				/* set timer 0 to interrupt every 250us */
  TL0 = 26;
  TR0 = 1;              /* start timer 0 */
  ET0 = 1;				/* enable timer 0 interrupt */

  init_comm(BAUD_19200); /* initialize serial communications */

  clear_buffer();
  device_off();
  boot_enable();
  
  EA = 1;               /* enable interrupts */

/*-------------------*/
/* main program loop */
/*-------------------*/

  printf("\n\r  --------------------------------------  ");
  printf("\n\r |   EEE DD   A     Electronic          | ");
  printf("\n\r |   EE  D D AAA       Design           | ");
  printf("\n\r |   EEE DD  A A          Associates    | ");
  printf("\n\r |                                      | ");
  printf("\n\r |   Model PRG-2051 Device Programmer   | ");
  printf("\n\r |    Copyright (c) 1996,1997 E.D.A.    | ");
  printf("\n\r  --------------------------------------  ");

  printf("\n\r\n\rType ? and press ENTER for help.");
  printf("\n\r\n\r>");

  while(1) {
    keyboard();                 /* sevice keyboard (serial port) */
    if (message) do_comm();     /* service message */
  }

}

/*-----------------------------------------*/
/* timer0 interrupt - executed every 250us */
/*-----------------------------------------*/
void t0isr() interrupt 1 using 2
{
char ctemp;

  ctemp=get_data();		/* reading this strobes the DS1232 watchdog timer */
  if (mstimer) mstimer--;
}
