/*---------------------------------------------------------------------------*/
/*                                PRG-2051                                   */
/*                                                                           */
/* Device programmer for the Atmel 89C2051 and 89C1051 microcontrollers.     */
/*                                                                           */
/* Filename:    PRG2051.H                                                    */
/* Description: PRG-2051 project header file.                                */
/*                                                                           */
/* Copyright (c) 1995,1996,1997 Electronic Design Associates.                */
/* All rights reserved.                                                      */
/*                                                                           */
/*---------------------------------------------------------------------------*/

#pragma LARGE
#pragma CODE
#pragma PW(75)
#pragma INTVECTOR

#define ATMEL_89C1051  (char)1
#define ATMEL_89C2051  (char)2

#define WRITE_DATA  (char)0x70
#define READ_DATA   (char)0x30
#define LOCK_BIT1   (char)0xf0
#define LOCK_BIT2   (char)0xc0
#define CHIP_ERASE  (char)0x80
#define READ_SIGN   (char)0x00
#define FLOAT       (char)0xf0

#define BUFFER_SIZE 2048

#define END_RECORD  (char)1

#define BAUD_1200   (char)0
#define BAUD_2400   (char)1
#define BAUD_4800   (char)2
#define BAUD_9600   (char)3
#define BAUD_19200  (char)4

#define NULL 0

